
// Generic Form version 2
// Programming and Designing Browser Interfaces
// Part 3, Chapter 6 - Organization
// written by Unknown Person

#include "GenericForm.dm" // include definition for Generic Form V2

genericForm/alert
  window_name = "Alert"
  window_params = "size=300x150&can_close=0&can_minimize=0"
  var
    message // the message that is displayed in the alert box
    self

  New(client/_owner, _message)
    self = src // to prevent the garbage collector from deleting the unreferenced object
    src.message = _message
    ..()

  Topic(href, list/href_list)
    . = ..()
    if(.)
      if(href_list["action"] == "close")
        del(src)

  GeneratePage()
    var/js = {"
    function action(action) {
      window.location="byond://?src=\ref[src]&action="+action;
    }"}
    var/style = "body { text-align: center } button {width: 100px }"
    var/page = {"
      <table width="100%" height="100%">
        <tr height="80%" align="center"><td><p>[src.message]</p></td></tr>
        <tr height="20%" align="center" valign="bottom"><td>
        <button onclick="action('close');">Close</button>
        </td></tr>
      </table>
    "}

    UpdatePage(page, style, js)