
// Section 6 - "Organization", Example 8
// An extention of Generic Form V2 that lets us easily define another
// generic form that gives us an interface for simple HTML alert boxes

#include "S6E06.dm" // include definition for Generic Form V2

genericForm/alert
  window_name = "Alert"
  window_params = "size=300x150&can_close=0&can_minimize=0"
  var
    message // the message that is displayed in the alert box
    self

  New(client/_owner, _message)
    self = src // to prevent the garbage collector from deleting the unreferenced object
    src.message = _message
    ..()

  Topic(href, list/href_list)
    . = ..()
    if(.)
      if(href_list["action"] == "close")
        del(src)

  GeneratePage()
    var/js = {"
    function action(action) {
      window.location="byond://?src=\ref[src]&action="+action;
    }"}
    var/style = "body { text-align: center } button {width: 100px }"
    var/page = {"
      <table width="100%" height="100%">
        <tr height="80%" align="center"><td><p>[src.message]</p></td></tr>
        <tr height="20%" align="center" valign="bottom"><td>
        <button onclick="action('close');">Close</button>
        </td></tr>
      </table>
    "}

    UpdatePage(page, style, js)