
// Section 6 - "Organization", Example 4
// Generic Form version 1.  Demonstrates and provides a very basic interface
// for forms to be defined.

// Generic Form version 1

mob/var
  form // the form the user is currently viewing

genericForm
  var
    client/owner // the viewer of the form

    window_name = "Generic Form" // name of title bar and browser window id
    window_params = "" // any other generic parameters sent through browse()
    body = "" // the html to be displayed to the viewer

  New(client/_owner)
    ..()
    src.owner = _owner
    DisplayPage() // display any page right when it's instantiated

  Del()
    owner << browse(null, "window=[src.window_name]")
    ..()

  proc
    UpdatePage(bodyText)
      src.body = {"
        <html>
        <head> <title> [src.window_name] </title> </head>
        <body> [bodyText] </body>
        </html>
      "}

    GeneratePage()
      // Generate the page text and layout by calling UpdatePage() with the body
      // To be implemented in children types

    DisplayPage()
      // first generate the page text, then display the page to the owner
      GeneratePage()
      owner << browse(body, "window=[src.window_name]&[window_params]")


